function [dAcc,mClasses,vLabelsAssigned,vAssignments] = LabelNewData(oModel,oData)
    if(iscell(oData.labels))
        vNumLabels      = str2num(cell2mat(oData.labels));
    else
        vNumLabels      = oData.labels;
    end
    vUniqueLabels   = unique(vNumLabels);
    iNumberOfLabels = length(vUniqueLabels);
    iNumberOfClusters = size(oModel.mAlpha,1);
    iNumberOfPoints = length(vNumLabels); 
    mClasses        = zeros(iNumberOfClusters,iNumberOfLabels);
    
    vAssignments    = apply_model(oModel,oData.data);
    for(k=1:iNumberOfClusters)
        B = zeros(iNumberOfLabels,1);
        for(r=1:iNumberOfLabels)
            B(r) = sum(vNumLabels(find(vAssignments==k))==vUniqueLabels(r));
            mClasses(k,r) = B(r);
        end
    end
    vLabelsAssigned = oModel.PrototypeLabels(vAssignments);
    dAcc = sum(vLabelsAssigned(:) == vNumLabels(:))/iNumberOfPoints