function kval = rbf_matlab(u,v,rbf_sigma,varargin)
 
if nargin < 3 || isempty(rbf_sigma)
    rbf_sigma = 1;
end
bLog = false;
if(nargin == 4)
    bLog = true;
end
if(size(u,1)*size(v,1)<1e7)
    kval = exp(-rbf_sigma*bsxfun(@plus,bsxfun(@minus,sum(u.^2,2),2*(u*v')),sum(v.^2,2)'));
else
    iU = size(u,1);
    iV = size(v,1);
    kval = zeros(iU,iV);
    if(bLog)
        fprintf('\n calculate u*u');
    end
    if(iU<=1000)
        vDiags1 = sum(u.^2,2)';%self_inner_product_mex(full(u),full(u));    % guess thats not to large
    else % split
        vBlocks = ceil(linspace(1,iU,100));
        vDiags1 = zeros(iU,1);
        for(k=1:100)
            iStart = vBlocks(k);
            iEnd   = vBlocks(min(k+1,end));
            vRange = iStart:iEnd;
            vDiags1(vRange) = sum(u(vRange,:).^2,2); %self_inner_product_mex(full(u(vRange,:)),full(u(vRange,:)));    
            if(bLog)
                fprintf('*')
            end
        end
    end
    if(bLog)
        fprintf('\n calculate v*v');
    end
    if(iV<=1000)
        vDiags2 = sum(v.^2,2)'; %self_inner_product_mex(full(v),full(v));    % guess thats not to large
    else % split
        vBlocks = ceil(linspace(1,iV,100));
        vDiags2 = zeros(1,iV); % primed
        for(k=1:100)
            iStart = vBlocks(k);
            iEnd   = vBlocks(min(k+1,end));
            vRange = iStart:iEnd;
            vDiags2(vRange) = sum(v(vRange,:).^2,2);%self_inner_product_mex(full(v(vRange,:)),full(v(vRange,:)));    
            if(bLog)
                fprintf('*')
            end
        end
    end    
    if(bLog)
        fprintf('\n calculate main kernel');
        tic
    end
    for(k=1:iU)
        kval(k,:) = exp(-rbf_sigma*bsxfun(@plus,bsxfun(@minus,vDiags1(k),2*(u(k,:)*v')),vDiags2));
        if(bLog)
            fprintf('*')
            if(mod(k,50)==0)
                T=toc;
                fprintf('\n');
                warning('Long running op: %f percent est time remaining %f min\n',k/iU, (iU*(T/k) - T)/ 60);
            end
        end
    end
end