% load some dummy data
load iris_dataset

% normalized N(0,1)
mD = bsxfun(@rdivide,bsxfun(@minus,irisInputs',mean(irisInputs')),std(irisInputs'));

% set parameters (#cluster, core tolerance, cycles, kernel function to use)
K  = 6
epsilon = 0.1
iCycles = 10
fKernel = @(X,Y)rbf_matlab(X,Y,0.5)

% single call of the clustering
[mAlpha,vWinners,vConvergenceTest] = core_ng(mD,K,epsilon,iCycles,fKernel)

% crossvalidation given you are interested on labeled predictions (which of
% course are not so expressive for clustering methods)
[vModelResults,vClassifyResults,vT] = crossvalidation_cng(@core_ng, struct('data',mD,'labels',[zeros(50,1);ones(50,1);2*ones(50,1)]), 5, {K,epsilon,iCycles,fKernel})
